#include "Poco/Thread.h"
#include "Poco/ThreadPool.h"
#include "Poco/RunnableAdapter.h"
#include "Poco/Runnable.h"
#include <iostream>
#include <unistd.h>
int test1=0;
int test2=0;
bool test3=true;
class ThreadClass: public Poco::Runnable
{
public:
    ThreadClass(const std::string& arg1, int arg2){
        this->arg1=arg1;
        this->arg2 = arg2;
    }
    void greet()
    {
        std::cout << "Hello, world!" << std::endl;
        test1++;
    }
    void run()
    {
        for(int i=0;i<3;i++){
            usleep(100000);
            std::cout<<i << std::endl;
            test2++;
        }
    }
    void say_args(){
        std::cout<<this->arg1<<" : "<<this->arg2<<std::endl;
        if(this->arg2==1){
            if(this->arg1!="one"){
                test3=false;
            }
        }
        if(this->arg2==2){
            if(this->arg1!="two"){
                test3=false;
            }
        }
        if(this->arg2==3){
            if(this->arg1!="three"){
                test3=false;
            }
        }
    }
private:
    std::string arg1;
    int arg2;
};
int main(int argc, char** argv)
{
    //thread start & join
    ThreadClass greeter("",0);
    Poco::RunnableAdapter<ThreadClass> runnable(greeter, &ThreadClass::greet);
    Poco::Thread thread[2];
    thread[0].start(runnable);
    thread[1].start(runnable);
    thread[0].join();
    thread[1].join();

    //threadpool
    ThreadClass run("",0);
    for (int i = 0; i < 5; ++i) {
        Poco::ThreadPool::defaultPool().start(run);
    }
    //thread all join
    Poco::ThreadPool::defaultPool().joinAll();


    //argument passing ( 클래스의 인자로 전달하는 방식 )
    ThreadClass arg_test1("one",1);
    ThreadClass arg_test2("two",2);
    ThreadClass arg_test3("three",3);
    Poco::RunnableAdapter<ThreadClass> argtst1(arg_test1, &ThreadClass::say_args);
    Poco::RunnableAdapter<ThreadClass> argtst2(arg_test2, &ThreadClass::say_args);
    Poco::RunnableAdapter<ThreadClass> argtst3(arg_test3, &ThreadClass::say_args);
    Poco::Thread arg_thread[3];
    arg_thread[0].start(argtst1);
    arg_thread[1].start(argtst2);
    arg_thread[2].start(argtst3);
    arg_thread[0].join();
    arg_thread[1].join();
    arg_thread[2].join();


    std::cout<<std::endl;
    std::cout<<"test 1 : basic thread test ..."<<(test1==2?"ok":"fail")<<std::endl;
    std::cout<<"test 2 : thread pool test ..."<<(test2==15?"ok":"fail")<<std::endl;
    std::cout<<"test 3 : argument test ..."<<(test3?"ok":"fail")<<std::endl;

    return 0;
}